#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Oct 17 14:19:31 2024

@author: user
"""

A = [23, 26, 29, 40, 45, 65, 70, 71, 87, 90] #A: a set of 10 numbers from [100]
n = len(A) #n: the size of A
#B: a binary word that encodes the subsets of A
#B[i] = 1 if the i-th element of A belongs to the subset
#B[i] = 0 if the i-th element of A does not belong to the subset
B = [0 for pos in range(len(A))] #Initially B encodes the empty set

def sumsubset(B): #get the sum of elements of A that belong to the subset encoded by B
    s = 0
    for i in range(len(B)): s += B[i]*A[i]
    return s

def getsubset(B): #get the subset of A that is encoded by the binary representation B
    subset = []
    for i in range(len(B)): 
        if B[i] == 1: subset.append(A[i])
    return subset

# mydict: dictionary to store the computed sums of elements for each subset of A
# Used during the generation of subsets in order to find two subsets with the same sum
# In mydict the pair key : value is sum of elements of subset : subset of A
mydict = {} # Initially mydict is empty

def subsetRec(k): #recursive generation of subsets of A using binary representation B of a subset
    if k >= n:
        s = sumsubset(B)
        if s in mydict: print("Sets",getsubset(B),"and",mydict[s],"have the same sum of elements:",s)
        else: mydict[s] = getsubset(B)
    else:
        B[k] = 0
        subsetRec(k+1)
        B[k] = 1
        subsetRec(k+1)

subsetRec(0) # Starts the recursion